<template>
  <div ref="selectMultiple" class="w-300 selectMultiple" @click.stop>
    <label v-if="label" class="label">{{ label }}</label>
    <div class="select flex justify-between items-center cursor-pointer" :class="[`${_class}`]" @click="viewList()">
      <div class="text-selected">
        <span class="select-none"
          ><b>{{ value.length }}</b> Elementos seleccionados</span
        >
      </div>
      <span class="flex flex-col">
        <ChevronUpIcon size="14"></ChevronUpIcon>
        <ChevronDownIcon size="14"></ChevronDownIcon>
      </span>
    </div>
    <div :id="id" ref="listOptions" class="47f85e05-95e1-4753-ad2d-63d33963364a listOptions ul" @click.stop>
      <div class="box-input flex items-center">
        <SearchIcon size="14" class="mr-2"></SearchIcon>
        <input v-model.trim="search" class="text-input" type="tex" placeholder="Buscar..." />
      </div>
      <ul class="overflow-auto">
        <li
          class="cursor-pointer li select-none"
          :class="{ success: value.map((_item) => _item.value).includes(item.value) }"
          v-for="(item, i) in items"
          :key="i"
          @click="SelectedItem(item)"
        >
          {{ item.text }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
  // import "./main.css";
  import { v4 as uuidv4 } from "uuid";
  import { SearchIcon, ChevronDownIcon, ChevronUpIcon } from "vue-feather-icons";
  export default {
    name: "SelectMultipleOpions", // vue component name
    props: {
      label: {
        required: false,
        type: String,
        default: "",
      },
      Clases: {
        required: false,
        type: String,
        default: "",
      },
      Items: {
        required: true,
        type: Array,
        default: () => [],
      },
      value: {
        required: true,
        type: Array,
      },
      reduce: {
        required: false,
        type: Function,
      },
    },
    data: () => ({
      id: uuidv4(),
      selected: [],
      search: "",
    }),
    mounted() {
      this.selected = this.value;
      const listOptions = this.$refs.listOptions;
      this.removeAllList();
      document.addEventListener("click", () => {
        listOptions.remove();
      });
    },
    methods: {
      viewList() {
        if (this.existList() === null) {
          this.removeAllList();
          const inputSelect = this.$refs.selectMultiple;
          const { width, x, y, height } = inputSelect.getBoundingClientRect();
          this.$refs.listOptions.style.width = `${width - 2}px`;
          this.$refs.listOptions.style.top = `${y + height}px`;
          // this.$refs.listOptions.style.zIndex = `10000000`;
          this.$refs.listOptions.style.left = `${x}px`;
          this.$refs.listOptions.classList.add("active");
          document.body.insertBefore(this.$refs.listOptions, null);
        } else {
          this.removeAllList();
        }
      },
      SelectedItem(item) {
        const index = this.selected.findIndex((_item) => _item.value === item.value);
        if (index > -1) {
          this.selected = this.selected.filter((_item) => _item.value !== item.value);
        } else this.selected.push(item);

        if (this.reduce) {
          const data = this.selected.map(this.reduce);
          this.$emit("dataReduce", data);
        }
        this.$emit("input", this.selected);
      },
      removeAllList() {
        const allListOptions = document.getElementsByClassName("47f85e05-95e1-4753-ad2d-63d33963364a");
        while (allListOptions.length > 0) {
          allListOptions[0].remove();
        }
      },
      existList() {
        const body = document.getElementById(`${this.id}`);
        return body;
      },
    },
    computed: {
      items() {
        if (this.search.trim().length > 0) {
          return this.Items.filter((item) => item.text.trim().toLowerCase().includes(this.search.trim().toLowerCase()));
        }
        return this.Items;
      },
      _class() {
        return this.Clases;
      },
    },
    components: { SearchIcon, ChevronDownIcon, ChevronUpIcon },
  };
</script>

<style scoped src="./style.css"></style>
<style scoped src="./main.css"></style>
